﻿
using System;
using System.Data;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication3
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = CreateTable(false);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = CreateTable(true);
        }

        private DataTable CreateTable(bool withBoolColumn)
        {
            // Create a new DataTable.
            DataTable table = new DataTable("ParentTable");
            // Declare variables for DataColumn and DataRow objects.

            // Create new DataColumn, set DataType, 
            // ColumnName and add to DataTable.    
            DataColumn column = new DataColumn();
            column.DataType = Type.GetType("System.Int32");
            column.ColumnName = "id";
            column.ReadOnly = true;
            column.Unique = true;
            // Add the Column to the DataColumnCollection.
            table.Columns.Add(column);

            // Create second column.
            column = new DataColumn();
            column.DataType = Type.GetType("System.String");
            column.ColumnName = "ParentItem";
            column.AutoIncrement = false;
            column.Caption = "ParentItem";
            column.ReadOnly = false;
            column.Unique = false;
            // Add the column to the table.
            table.Columns.Add(column);

            if (withBoolColumn)
            {
                column = new DataColumn();
                column.DataType = typeof (bool);
                column.ColumnName = "bool";
                column.AutoIncrement = false;
                column.Caption = "bool";
                column.ReadOnly = false;
                column.Unique = false;
                // Add the column to the table.
                table.Columns.Add(column);
            }
            // Make the ID column the primary key column.
            DataColumn[] primaryKeyColumns = new DataColumn[1];
            primaryKeyColumns[0] = table.Columns["id"];
            table.PrimaryKey = primaryKeyColumns;

            // Create three new DataRow objects and add 
            // them to the DataTable
            for (int i = 0; i <= 20; i++)
            {
                DataRow row = table.NewRow();
                row["id"] = i;
                row["ParentItem"] = "ParentItem " + i;
                if (withBoolColumn)
                {
                    row["bool"] = i%2 == 0;
                }
                table.Rows.Add(row);
            }

            return table;
        }

        public static ValueList GetYesNoListForBool()
        {
            ValueList valueList = new ValueList();
            valueList.ValueListItems.Add(true, "Yes");
            valueList.ValueListItems.Add(false, "No");
            return valueList;
        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            if (e.Layout.Bands[0].Columns.Exists("bool"))
            {
                UltraGridColumn column = e.Layout.Bands[0].Columns["bool"];
                column.FilterOperandStyle = FilterOperandStyle.DropDownList;
                ValueList valueList = GetYesNoListForBool();
                column.ValueList = valueList;
            }
        }
    }
}